$(() => {
$('#scheduler').dxScheduler({
dataSource: data,
views: ['workWeek', 'month'],
currentView: 'workWeek',
currentDate: new Date(2021, 3, 27),
firstDayOfWeek: 0,
startDayHour: 9,
endDayHour: 19,
showAllDayPanel: false,
height: 730,
dataCellTemplate(itemData, itemIndex, itemElement) {
const date = itemData.startDate;
const element = $('<div />');
if (isDisableDate(date)) {
element.addClass('disable-date');
} else if (isDinner(date)) {
element.addClass('dinner');
}
const isMonth = this.option('currentView') === 'month';
if (isMonth) {
element.text(date.getDate());
element.addClass('dx-scheduler-date-table-cell-text');
}
return itemElement.append(element);
},
dateCellTemplate(itemData, itemIndex, itemElement) {
const element = $(`<div>${itemData.text}</div>`);
const isMonth = this.option('currentView') === 'month';
const isDisabled = isMonth
? isWeekend(itemData.date)
: isDisableDate(itemData.date);
if (isDisabled) {
element.addClass('disable-date');
}
return itemElement.append(element);
},
timeCellTemplate(itemData, itemIndex, itemElement) {
const element = $(`<div>${itemData.text}</div>`);
const { date } = itemData;
if (isDinner(date)) {
element.addClass('dinner');
}
if (hasCoffeeCupIcon(date)) {
element.append('<div class="cafe" />');
}
return itemElement.append(element);
},
onContentReady(e) {
setComponentAria(e.component.$element());
},
onAppointmentFormOpening(e) {
const startDate = new Date(e.appointmentData.startDate);
if (!isValidAppointmentDate(startDate)) {
e.cancel = true;
notifyDisableDate();
}
applyDisableDatesToDateEditors(e.form);
},
onAppointmentAdding(e) {
if (!isValidAppointment(e.component, e.appointmentData)) {
e.cancel = true;
notifyDisableDate();
}
},
onAppointmentUpdating(e) {
if (!isValidAppointment(e.component, e.newData)) {
e.cancel = true;
notifyDisableDate();
}
},
});
});
const dinnerTime = { from: 12, to: 13 };
const holidays = [
new Date(2021, 3, 29),
new Date(2021, 5, 6),
];
const ariaDescription = () => {
const disabledDates = holidays
.filter((date) => !isWeekend(date))
.map((date) => new Date(date).toLocaleDateString('en-US', {
weekday: 'long',
year: 'numeric',
month: 'long',
day: 'numeric',
}),
);
if (disabledDates?.length === 1) {
return `${disabledDates} is a disabled date`;
}
if (disabledDates?.length > 1) {
return `${disabledDates.join(', ')} are disabled dates`;
}
return '';
};
function notifyDisableDate() {
DevExpress.ui.notify('Cannot create or move an appointment/event to disabled time/date regions.', 'warning', 1000);
}
function isValidAppointment(component, appointmentData) {
const startDate = new Date(appointmentData.startDate);
const endDate = new Date(appointmentData.endDate);
const cellDuration = component.option('cellDuration');
return isValidAppointmentInterval(startDate, endDate, cellDuration);
}
function isValidAppointmentInterval(startDate, endDate, cellDuration) {
const edgeEndDate = new Date(endDate.getTime() - 1);
if (!isValidAppointmentDate(edgeEndDate)) {
return false;
}
const durationInMs = cellDuration * 60 * 1000;
const date = startDate;
while (date <= endDate) {
if (!isValidAppointmentDate(date)) {
return false;
}
const newDateTime = date.getTime() + durationInMs - 1;
date.setTime(newDateTime);
}
return true;
}
function isValidAppointmentDate(date) {
return !isHoliday(date) && !isDinner(date) && !isWeekend(date);
}
function isHoliday(date) {
const localeDate = date.toLocaleDateString();
return holidays.filter((holiday) => holiday.toLocaleDateString() === localeDate).length > 0;
}
function isWeekend(date) {
const day = date.getDay();
return day === 0 || day === 6;
}
function isDisableDate(date) {
return isHoliday(date) || isWeekend(date);
}
function isDinner(date) {
const hours = date.getHours();
return hours >= dinnerTime.from && hours < dinnerTime.to;
}
function hasCoffeeCupIcon(date) {
const hours = date.getHours();
const minutes = date.getMinutes();
return hours === dinnerTime.from && minutes === 0;
}
function applyDisableDatesToDateEditors(form) {
const startDateEditor = form.getEditor('startDate');
startDateEditor.option('disabledDates', holidays);
const endDateEditor = form.getEditor('endDate');
endDateEditor.option('disabledDates', holidays);
}
function setComponentAria(element) {
const prevAria = element?.attr('aria-label') || '';
const description = ariaDescription();
const nextAria = `${prevAria}${description ? ` ${description}` : ''}`;
element?.attr('aria-label', nextAria);
}
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.3"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="scheduler"></div>
</div>
</body>
</html>
/* stylelint-disable-next-line at-rule-no-vendor-prefix, at-rule-prelude-no-invalid */
@-moz-document url-prefix() {
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell {
position: relative;
}
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell .disable-date {
position: absolute;
width: 100%;
height: 100%;
}
}
.disable-date,
.dinner {
height: 100%;
width: 100%;
}
.disable-date {
background-image:
repeating-linear-gradient(
135deg,
var(--dx-datagrid-row-alternation-bg),
var(--dx-datagrid-row-alternation-bg) 2px,
transparent 2px,
transparent 6px
);
color: var(--dx-color-success);
}
.dx-scheduler-header-panel-cell .disable-date {
display: flex;
flex-direction: column;
justify-content: center;
}
.dx-theme-fluent .dx-scheduler-header-panel-cell .disable-date,
.dx-theme-material .dx-scheduler-header-panel-cell .disable-date {
flex-direction: row;
align-items: flex-end;
justify-content: initial;
}
.dinner {
background: var(--dx-datagrid-row-alternation-bg);
}
.dx-scheduler-time-panel-cell .dinner {
color: var(--dx-color-success);
font-weight: 400;
background: transparent;
}
.dx-draggable {
cursor: auto;
}
td.dx-scheduler-time-panel-cell .dinner .cafe {
height: 200%;
width: 100%;
left: 50%;
mask: url('data:image/svg+xml;utf8,<svg xmlns="http://www.w3.org/2000/svg" height="24" viewBox="0 0 24 24" width="24"><path d="M0 0h24v24H0V0z" fill="none"/><path d="M20 3H4v10c0 2.21 1.79 4 4 4h6c2.21 0 4-1.79 4-4v-3h2c1.11 0 2-.9 2-2V5c0-1.11-.89-2-2-2zm0 5h-2V5h2v3zM4 19h16v2H4z"/></svg>');
mask-repeat: no-repeat;
-webkit-mask-position-y: 50%;
-webkit-mask-position-x: 100%;
margin-top: -4px;
background-color: var(--dx-color-success);
}
.dx-scheduler-date-table-cell {
padding: 0;
opacity: 1;
}
@media all and (-ms-high-contrast: none) {
td.dx-scheduler-time-panel-cell .dinner .cafe {
background-color: transparent;
}
}
const data = [
{
text: 'Website Re-Design Plan',
startDate: new Date(2021, 3, 26, 9, 30),
endDate: new Date(2021, 3, 26, 11, 30),
},
{
text: 'Install New Router in Dev Room',
startDate: new Date(2021, 3, 26, 13),
endDate: new Date(2021, 3, 26, 14),
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2021, 3, 27, 10),
endDate: new Date(2021, 3, 27, 11),
},
{
text: 'Final Budget Review',
startDate: new Date(2021, 3, 27, 13, 30),
endDate: new Date(2021, 3, 27, 15),
},
{
text: 'New Brochures',
startDate: new Date(2021, 3, 26, 15),
endDate: new Date(2021, 3, 26, 16, 15),
},
{
text: 'Install New Database',
startDate: new Date(2021, 3, 28, 9, 45),
endDate: new Date(2021, 3, 28, 12),
},
{
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2021, 3, 28, 14, 30),
endDate: new Date(2021, 3, 28, 16, 30),
},
{
text: 'Upgrade Personal Computers',
startDate: new Date(2021, 3, 27, 15, 30),
endDate: new Date(2021, 3, 27, 16, 45),
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2021, 4, 3, 13),
endDate: new Date(2021, 4, 3, 15),
},
{
text: 'Brochure Design Review',
startDate: new Date(2021, 4, 4, 15, 30),
endDate: new Date(2021, 4, 5),
},
{
text: 'Create Icons for Website',
startDate: new Date(2021, 3, 30, 10),
endDate: new Date(2021, 3, 30, 12),
},
{
text: 'Upgrade Server Hardware',
startDate: new Date(2021, 3, 30, 16, 30),
endDate: new Date(2021, 3, 30, 18),
},
{
text: 'Submit New Website Design',
startDate: new Date(2021, 4, 5, 10),
endDate: new Date(2021, 4, 5, 11, 30),
},
{
text: 'Launch New Website',
startDate: new Date(2021, 3, 30, 14, 30),
endDate: new Date(2021, 3, 30, 16, 10),
},
];

<template>
<DxScheduler
:data-source="dataSource"
:current-date="currentDate"
:views="views"
v-model:current-view="currentView"
:height="730"
:show-all-day-panel="false"
:first-day-of-week="0"
:start-day-hour="9"
:end-day-hour="19"
data-cell-template="dataCellTemplate"
date-cell-template="dateCellTemplate"
time-cell-template="timeCellTemplate"
:on-content-ready="onContentReady"
:on-appointment-form-opening="onAppointmentFormOpening"
:on-appointment-adding="onAppointmentAdding"
:on-appointment-updating="onAppointmentUpdating"
>
<template #dataCellTemplate="{ data: cellData }">
<DataCellMonth
v-if="isMonthView"
:cell-data="cellData"
/>
<DataCell
v-else
:cell-data="cellData"
/>
</template>
<template #dateCellTemplate="{ data: cellData }">
<DateCell
:cell-data="cellData"
:current-view="currentView"
/>
</template>
<template #timeCellTemplate="{ data: cellData }">
<TimeCell :cell-data="cellData"/>
</template>
</DxScheduler>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import { DxForm } from 'devextreme-vue';
import { DxScheduler, type DxSchedulerTypes } from 'devextreme-vue/scheduler';
import notify from 'devextreme/ui/notify';
import { data, holidays } from './data.ts';
import Utils from './utils.ts';
import DataCell from './DataCell.vue';
import DataCellMonth from './DataCellMonth.vue';
import DateCell from './DateCell.vue';
import TimeCell from './TimeCell.vue';
const views: DxSchedulerTypes.ViewType[] = ['workWeek', 'month'];
const currentView = ref<DxSchedulerTypes.ViewType>('workWeek');
const currentDate = new Date(2021, 3, 27);
const dataSource = data;
const isMonthView = computed(() => currentView.value === 'month');
const ariaDescription = computed(() => {
const disabledDates = holidays
.filter((date) => !Utils.isWeekend(date))
.map((date) => new Date(date).toLocaleDateString('en-US', {
weekday: 'long',
year: 'numeric',
month: 'long',
day: 'numeric',
}),
);
if (disabledDates?.length === 1) {
return `${disabledDates} is a disabled date`;
}
if (disabledDates?.length > 1) {
return `${disabledDates.join(', ')} are disabled dates`;
}
return '';
});
function onContentReady(e: DxSchedulerTypes.ContentReadyEvent) {
setComponentAria(e.component?.$element());
}
function onAppointmentFormOpening(e: DxSchedulerTypes.AppointmentFormOpeningEvent) {
if (e.appointmentData?.startDate
&& !Utils.isValidAppointmentDate(new Date(e.appointmentData.startDate))) {
e.cancel = true;
notifyDisableDate();
applyDisableDatesToDateEditors(e.form);
}
}
function onAppointmentAdding(e: DxSchedulerTypes.AppointmentAddingEvent) {
const isValidAppointment = Utils.isValidAppointment(e.component, e.appointmentData);
if (!isValidAppointment) {
e.cancel = true;
notifyDisableDate();
}
}
function onAppointmentUpdating(e: DxSchedulerTypes.AppointmentUpdatingEvent) {
const isValidAppointment = Utils.isValidAppointment(e.component, e.newData);
if (!isValidAppointment) {
e.cancel = true;
notifyDisableDate();
}
}
function notifyDisableDate() {
notify('Cannot create or move an appointment/event to disabled time/date regions.', 'warning', 1000);
}
function applyDisableDatesToDateEditors(form: DxForm['instance']) {
if (!form) {
return;
}
const startDateEditor = form.getEditor('startDate');
startDateEditor?.option('disabledDates', holidays);
const endDateEditor = form.getEditor('endDate');
endDateEditor?.option('disabledDates', holidays);
}
function setComponentAria(element: Record<string, any>) {
const prevAria = element?.attr('aria-label') || '';
const description = ariaDescription.value;
const nextAria = `${prevAria}${description ? ` ${description}` : ''}`;
element?.attr('aria-label', nextAria);
}
</script>
<template>
<div :class="markDataCell(cellData)">
<slot/>
</div>
</template>
<script setup lang="ts">
import Utils from './utils.ts';
defineProps<{
cellData: Record<string, any>
}>();
function markDataCell(cellData: Record<string, any>) {
const date = cellData.startDate;
const isDisableDate = Utils.isHoliday(date) || Utils.isWeekend(date);
const isDinner = !isDisableDate && Utils.isDinner(date);
return {
'disable-date': isDisableDate,
dinner: isDinner,
};
}
</script>
<template>
<DataCell
class="dx-scheduler-date-table-cell-text"
:cell-data="cellData"
>
{{ day() }}
</DataCell>
</template>
<script setup lang="ts">
import DataCell from './DataCell.vue';
const props = defineProps<{
cellData: Record<string, any>
}>();
function day() {
return props.cellData.startDate.getDate();
}
</script>
<template>
<div :class="markDateCell(cellData, currentView)">
{{ cellData.text }}
</div>
</template>
<script setup lang="ts">
import Utils from './utils.ts';
withDefaults(defineProps<{
cellData?: any
currentView?: string
}>(), {
cellData: () => {},
currentView: '',
});
function markDateCell(cellData: Record<string, any>, currentView: string) {
const isDisabled = currentView === 'month'
? Utils.isWeekend(cellData.date)
: Utils.isDisableDate(cellData.date);
return { 'disable-date': isDisabled };
}
</script>
<template>
<div :class="markTimeCell(cellData)">
{{ cellData.text }}
<div
v-if="hasCoffeeCupIcon"
class="cafe"
/>
</div>
</template>
<script setup lang="ts">
import { computed } from 'vue';
import Utils from './utils.ts';
const props = withDefaults(defineProps<{
cellData?: any
}>(), {
cellData: () => {},
});
const hasCoffeeCupIcon = computed(() => {
const { date } = props.cellData;
return Utils.hasCoffeeCupIcon(date);
});
function markTimeCell(cellData: Record<string, any>) {
return { dinner: Utils.isDinner(cellData.date) };
}
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const dinnerTime = { from: 12, to: 13 };
export const holidays = [
new Date(2021, 3, 29),
new Date(2021, 5, 6),
];
export const data = [
{
text: 'Website Re-Design Plan',
startDate: new Date(2021, 3, 26, 9, 30),
endDate: new Date(2021, 3, 26, 11, 30),
},
{
text: 'Install New Router in Dev Room',
startDate: new Date(2021, 3, 26, 13),
endDate: new Date(2021, 3, 26, 14),
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2021, 3, 27, 10),
endDate: new Date(2021, 3, 27, 11),
},
{
text: 'Final Budget Review',
startDate: new Date(2021, 3, 27, 13, 30),
endDate: new Date(2021, 3, 27, 15),
},
{
text: 'New Brochures',
startDate: new Date(2021, 3, 26, 15),
endDate: new Date(2021, 3, 26, 16, 15),
},
{
text: 'Install New Database',
startDate: new Date(2021, 3, 28, 9, 45),
endDate: new Date(2021, 3, 28, 12),
},
{
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2021, 3, 28, 14, 30),
endDate: new Date(2021, 3, 28, 16, 30),
},
{
text: 'Upgrade Personal Computers',
startDate: new Date(2021, 3, 27, 15, 30),
endDate: new Date(2021, 3, 27, 16, 45),
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2021, 4, 3, 13),
endDate: new Date(2021, 4, 3, 15),
},
{
text: 'Brochure Design Review',
startDate: new Date(2021, 4, 4, 15, 30),
endDate: new Date(2021, 4, 5),
},
{
text: 'Create Icons for Website',
startDate: new Date(2021, 3, 30, 10),
endDate: new Date(2021, 3, 30, 12),
},
{
text: 'Upgrade Server Hardware',
startDate: new Date(2021, 3, 30, 16, 30),
endDate: new Date(2021, 3, 30, 18),
},
{
text: 'Submit New Website Design',
startDate: new Date(2021, 4, 5, 10),
endDate: new Date(2021, 4, 5, 11, 30),
},
{
text: 'Launch New Website',
startDate: new Date(2021, 3, 30, 14, 30),
endDate: new Date(2021, 3, 30, 16, 10),
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
import type { DxScheduler } from 'devextreme-vue';
import { dinnerTime, holidays } from './data.ts';
export default class Utils {
static isHoliday(date: Date) {
const localeDate = date.toLocaleDateString();
return holidays.filter((holiday) => holiday.toLocaleDateString() === localeDate).length > 0;
}
static isWeekend(date: Date) {
const day = date.getDay();
return day === 0 || day === 6;
}
static isDisableDate(date: Date) {
return Utils.isHoliday(date) || Utils.isWeekend(date);
}
static isDinner(date: Date) {
const hours = date.getHours();
return hours >= dinnerTime.from && hours < dinnerTime.to;
}
static hasCoffeeCupIcon(date: Date) {
const hours = date.getHours();
const minutes = date.getMinutes();
return hours === dinnerTime.from && minutes === 0;
}
static isValidAppointment(component: DxScheduler['instance'], appointmentData: Record<string, any>) {
const startDate = new Date(appointmentData.startDate);
const endDate = new Date(appointmentData.endDate);
const cellDuration = component?.option('cellDuration') || 0;
return Utils.isValidAppointmentInterval(startDate, endDate, cellDuration);
}
static isValidAppointmentInterval(startDate: Date, endDate: Date, cellDuration: number) {
const edgeEndDate = new Date(endDate.getTime() - 1);
if (!Utils.isValidAppointmentDate(edgeEndDate)) {
return false;
}
const durationInMs = cellDuration * 60 * 1000;
const date = startDate;
while (date <= endDate) {
if (!Utils.isValidAppointmentDate(date)) {
return false;
}
const newDateTime = date.getTime() + durationInMs - 1;
date.setTime(newDateTime);
}
return true;
}
static isValidAppointmentDate(date: Date) {
return !Utils.isHoliday(date) && !Utils.isDinner(date) && !Utils.isWeekend(date);
}
}
/* stylelint-disable-next-line at-rule-no-vendor-prefix, at-rule-prelude-no-invalid */
@-moz-document url-prefix() {
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell {
position: relative;
}
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell .disable-date {
position: absolute;
width: 100%;
height: 100%;
}
}
.disable-date,
.dinner {
height: 100%;
width: 100%;
}
.disable-date {
background-image:
repeating-linear-gradient(
135deg,
var(--dx-datagrid-row-alternation-bg),
var(--dx-datagrid-row-alternation-bg) 2px,
transparent 2px,
transparent 6px
);
color: var(--dx-color-success);
}
.dx-scheduler-header-panel-cell .disable-date {
display: flex;
flex-direction: column;
justify-content: center;
}
.dx-theme-fluent .dx-scheduler-header-panel-cell .disable-date,
.dx-theme-material .dx-scheduler-header-panel-cell .disable-date {
flex-direction: row;
align-items: flex-end;
justify-content: initial;
}
.dinner {
background: var(--dx-datagrid-row-alternation-bg);
}
.dx-scheduler-time-panel-cell .dinner {
color: var(--dx-color-success);
font-weight: 400;
background: transparent;
}
.dx-draggable {
cursor: auto;
}
td.dx-scheduler-time-panel-cell .dinner .cafe {
height: 200%;
width: 100%;
left: 50%;
mask: url('data:image/svg+xml;utf8,<svg xmlns="http://www.w3.org/2000/svg" height="24" viewBox="0 0 24 24" width="24"><path d="M0 0h24v24H0V0z" fill="none"/><path d="M20 3H4v10c0 2.21 1.79 4 4 4h6c2.21 0 4-1.79 4-4v-3h2c1.11 0 2-.9 2-2V5c0-1.11-.89-2-2-2zm0 5h-2V5h2v3zM4 19h16v2H4z"/></svg>');
mask-repeat: no-repeat;
-webkit-mask-position-y: 50%;
-webkit-mask-position-x: 100%;
margin-top: -4px;
background-color: var(--dx-color-success);
}
.dx-scheduler-date-table-cell {
padding: 0;
opacity: 1;
}
@media all and (-ms-high-contrast: none) {
td.dx-scheduler-time-panel-cell .dinner .cafe {
background-color: transparent;
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-scheduler
[dataSource]="dataSource"
[views]="views"
[currentView]="currentView"
[currentDate]="currentDate"
[firstDayOfWeek]="0"
[startDayHour]="9"
[endDayHour]="19"
[showAllDayPanel]="false"
[height]="730"
dataCellTemplate="dataCellTemplate"
dateCellTemplate="dateCellTemplate"
timeCellTemplate="timeCellTemplate"
(onContentReady)="onContentReady($event)"
(onAppointmentFormOpening)="onAppointmentFormOpening($event)"
(onAppointmentAdding)="onAppointmentAdding($event)"
(onAppointmentUpdating)="onAppointmentUpdating($event)"
(onOptionChanged)="onOptionChanged($event)"
>
<div
*dxTemplate="let dataCell of 'dataCellTemplate'"
[class.disable-date]="isDisableDate | apply : dataCell.startDate"
[class.dx-scheduler-date-table-cell-text]="currentView === 'month'"
[class.dinner]="
!(isDisableDate | apply : dataCell.startDate) &&
(isDinner | apply : dataCell.startDate)
"
>
{{ currentView === "month" ? (dataCell.startDate | date) : "" }}
</div>
<div
*dxTemplate="let dateCell of 'dateCellTemplate'"
[class.disable-date]="isDisabledDateCell | apply : dateCell.date"
>
{{ dateCell.text }}
</div>
<div
*dxTemplate="let timeCell of 'timeCellTemplate'"
[class.dinner]="isDinner | apply : timeCell.date"
>
{{ timeCell.text }}
@if(hasCoffeeCupIcon | apply : timeCell.date){
<div class="cafe"></div>
}
</div>
</dx-scheduler>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, Pipe, PipeTransform, provideZoneChangeDetection } from '@angular/core';
import { DatePipe } from '@angular/common';
import { DxSchedulerComponent, DxSchedulerModule } from 'devextreme-angular';
import { DataSource } from 'devextreme-angular/common/data';
import notify from 'devextreme/ui/notify';
import { DxSchedulerTypes } from 'devextreme-angular/ui/scheduler';
import { DxFormComponent } from 'devextreme-angular/ui/form';
import { DataService } from './app.service';
@Pipe({ name: 'apply' })
export class ApplyPipe<TArgs, TReturn> implements PipeTransform {
transform(func: ((...args: TArgs[]) => TReturn), ...args: TArgs[]): TReturn { return func(...args); }
}
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [DataService],
imports: [
DxSchedulerModule,
ApplyPipe,
DatePipe,
],
})
export class AppComponent {
dataSource: DataSource;
dinnerTime: { from: number, to: number };
holidays: Date[];
currentDate = new Date(2021, 3, 27);
views = ['workWeek', 'month'];
currentView = this.views[0];
ariaDescription = () => {
const disabledDates = this.holidays
.filter((date) => !this.isWeekend(date))
.map((date) => new Date(date).toLocaleDateString('en-US', {
weekday: 'long',
year: 'numeric',
month: 'long',
day: 'numeric',
})
);
if (disabledDates?.length === 1) {
return `${disabledDates} is a disabled date`;
}
if (disabledDates?.length > 1) {
return `${disabledDates.join(', ')} are disabled dates`;
}
return '';
};
constructor(public dataService: DataService) {
this.dinnerTime = this.dataService.getDinnerTime();
this.holidays = this.dataService.getHolidays();
this.dataSource = new DataSource({
store: dataService.getData(),
});
}
onContentReady = (e: DxSchedulerTypes.ContentReadyEvent) => {
this.setComponentAria(e.component?.$element());
};
onOptionChanged = (e: DxSchedulerTypes.OptionChangedEvent) => {
if (e.name === 'currentView') {
this.currentView = e.value;
}
};
onAppointmentFormOpening = (e: DxSchedulerTypes.AppointmentFormOpeningEvent) => {
const startDate = e.appointmentData.startDate as Date;
if (!this.isValidAppointmentDate(startDate)) {
e.cancel = true;
this.notifyDisableDate();
}
this.applyDisableDatesToDateEditors(e.form);
};
onAppointmentAdding = (e: DxSchedulerTypes.AppointmentAddingEvent) => {
const isValidAppointment = this.isValidAppointment(e.component, e.appointmentData);
if (!isValidAppointment) {
e.cancel = true;
this.notifyDisableDate();
}
};
onAppointmentUpdating = (e: DxSchedulerTypes.AppointmentUpdatingEvent) => {
const isValidAppointment = this.isValidAppointment(e.component, e.newData);
if (!isValidAppointment) {
e.cancel = true;
this.notifyDisableDate();
}
};
notifyDisableDate = () => {
notify('Cannot create or move an appointment/event to disabled time/date regions.', 'warning', 1000);
};
isHoliday = (date: Date) => {
const localeDate = date.toLocaleDateString();
return this.holidays.filter((holiday) => holiday.toLocaleDateString() === localeDate).length > 0;
};
isWeekend = (date: Date) => {
const day = date.getDay();
return day === 0 || day === 6;
};
isDinner = (date: Date) => {
const hours = date.getHours();
return hours >= this.dinnerTime.from && hours < this.dinnerTime.to;
};
isDisableDate = (date: Date) => this.isHoliday(date) || this.isWeekend(date);
isDisabledDateCell = (date: Date) => (this.currentView === 'month' ? this.isWeekend(date) : this.isDisableDate(date));
hasCoffeeCupIcon = (date: Date) => {
const hours = date.getHours();
const minutes = date.getMinutes();
return hours === this.dinnerTime.from && minutes === 0;
};
isValidAppointment = (component: DxSchedulerComponent['instance'], appointmentData: DxSchedulerTypes.Appointment) => {
const startDate = new Date(appointmentData.startDate);
const endDate = new Date(appointmentData.endDate);
const cellDuration = component.option('cellDuration');
return this.isValidAppointmentInterval(startDate, endDate, cellDuration);
};
isValidAppointmentInterval = (startDate: Date, endDate: Date, cellDuration: number) => {
const edgeEndDate = new Date(endDate.getTime() - 1);
if (!this.isValidAppointmentDate(edgeEndDate)) {
return false;
}
const durationInMs = cellDuration * 60 * 1000;
const date = startDate;
while (date <= endDate) {
if (!this.isValidAppointmentDate(date)) {
return false;
}
const newDateTime = date.getTime() + durationInMs - 1;
date.setTime(newDateTime);
}
return true;
};
isValidAppointmentDate = (date: Date) => !this.isHoliday(date) && !this.isDinner(date) && !this.isWeekend(date);
applyDisableDatesToDateEditors = (form: DxFormComponent['instance']) => {
const holidays = this.dataService.getHolidays();
const startDateEditor = form.getEditor('startDate');
startDateEditor.option('disabledDates', holidays);
const endDateEditor = form.getEditor('endDate');
endDateEditor.option('disabledDates', holidays);
};
setComponentAria(element): void {
const prevAria = element?.attr('aria-label') || '';
const description = this.ariaDescription();
const nextAria = `${prevAria}${description ? ` ${description}` : ''}`;
element?.attr('aria-label', nextAria);
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
/* stylelint-disable-next-line at-rule-no-vendor-prefix, at-rule-prelude-no-invalid */
@-moz-document url-prefix() {
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell {
position: relative;
}
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell .disable-date {
position: absolute;
width: 100%;
height: 100%;
}
}
.disable-date,
.dinner {
height: 100%;
width: 100%;
}
::ng-deep .disable-date {
background-image:
repeating-linear-gradient(
135deg,
var(--dx-datagrid-row-alternation-bg),
var(--dx-datagrid-row-alternation-bg) 2px,
transparent 2px,
transparent 6px
);
color: var(--dx-color-success);
}
::ng-deep .dx-scheduler-header-panel-cell .disable-date {
display: flex;
flex-direction: column;
justify-content: center;
}
::ng-deep .dx-theme-fluent .dx-scheduler-header-panel-cell .disable-date,
::ng-deep .dx-theme-material .dx-scheduler-header-panel-cell .disable-date {
flex-direction: row;
align-items: flex-end;
justify-content: initial;
}
.dinner {
background: var(--dx-datagrid-row-alternation-bg);
}
::ng-deep .dx-scheduler-time-panel-cell .dinner {
color: var(--dx-color-success);
font-weight: 400;
background: transparent;
}
.dx-draggable {
cursor: auto;
}
::ng-deep td.dx-scheduler-time-panel-cell .dinner .cafe {
height: 200%;
width: 100%;
left: 50%;
mask: url('data:image/svg+xml;utf8,<svg xmlns="http://www.w3.org/2000/svg" height="24" viewBox="0 0 24 24" width="24"><path d="M0 0h24v24H0V0z" fill="none"/><path d="M20 3H4v10c0 2.21 1.79 4 4 4h6c2.21 0 4-1.79 4-4v-3h2c1.11 0 2-.9 2-2V5c0-1.11-.89-2-2-2zm0 5h-2V5h2v3zM4 19h16v2H4z"/></svg>');
mask-repeat: no-repeat;
-webkit-mask-position-y: 50%;
-webkit-mask-position-x: 100%;
margin-top: -4px;
background-color: var(--dx-color-success);
}
::ng-deep .dx-scheduler-date-table-cell {
padding: 0;
opacity: 1;
}
@media all and (-ms-high-contrast: none) {
::ng-deep td.dx-scheduler-time-panel-cell .dinner .cafe {
background-color: transparent;
}
}
import { Injectable } from '@angular/core';
export class Data {
text: string;
startDate: Date;
endDate: Date;
}
const data: Data[] = [
{
text: 'Website Re-Design Plan',
startDate: new Date(2021, 3, 26, 9, 30),
endDate: new Date(2021, 3, 26, 11, 30),
},
{
text: 'Install New Router in Dev Room',
startDate: new Date(2021, 3, 26, 13),
endDate: new Date(2021, 3, 26, 14),
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2021, 3, 27, 10),
endDate: new Date(2021, 3, 27, 11),
},
{
text: 'Final Budget Review',
startDate: new Date(2021, 3, 27, 13, 30),
endDate: new Date(2021, 3, 27, 15),
},
{
text: 'New Brochures',
startDate: new Date(2021, 3, 26, 15),
endDate: new Date(2021, 3, 26, 16, 15),
},
{
text: 'Install New Database',
startDate: new Date(2021, 3, 28, 9, 45),
endDate: new Date(2021, 3, 28, 12),
},
{
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2021, 3, 28, 14, 30),
endDate: new Date(2021, 3, 28, 16, 30),
},
{
text: 'Upgrade Personal Computers',
startDate: new Date(2021, 3, 27, 15, 30),
endDate: new Date(2021, 3, 27, 16, 45),
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2021, 4, 3, 13),
endDate: new Date(2021, 4, 3, 15),
},
{
text: 'Brochure Design Review',
startDate: new Date(2021, 4, 4, 15, 30),
endDate: new Date(2021, 4, 5),
},
{
text: 'Create Icons for Website',
startDate: new Date(2021, 3, 30, 10),
endDate: new Date(2021, 3, 30, 12),
},
{
text: 'Upgrade Server Hardware',
startDate: new Date(2021, 3, 30, 16, 30),
endDate: new Date(2021, 3, 30, 18),
},
{
text: 'Submit New Website Design',
startDate: new Date(2021, 4, 5, 10),
endDate: new Date(2021, 4, 5, 11, 30),
},
{
text: 'Launch New Website',
startDate: new Date(2021, 3, 30, 14, 30),
endDate: new Date(2021, 3, 30, 16, 10),
},
];
@Injectable()
export class DataService {
getData() {
return data;
}
getDinnerTime() {
return { from: 12, to: 13 };
}
getHolidays() {
return [
new Date(2021, 3, 29),
new Date(2021, 5, 6),
];
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React, { useCallback, useMemo, useState } from 'react';
import Scheduler from 'devextreme-react/scheduler';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import type { FormRef } from 'devextreme-react/form';
import notify from 'devextreme/ui/notify';
import { data, holidays } from './data.ts';
import Utils from './utils.ts';
import DataCell from './DataCell.tsx';
import DataCellMonth from './DataCellMonth.tsx';
import DateCell from './DateCell.tsx';
import TimeCell from './TimeCell.tsx';
const currentDate = new Date(2021, 3, 27);
const views: SchedulerTypes.ViewType[] = ['workWeek', 'month'];
const ariaDescription = () => {
const disabledDates = holidays
.filter((date) => !Utils.isWeekend(date))
.map((date) => new Date(date).toLocaleDateString('en-US', {
weekday: 'long',
year: 'numeric',
month: 'long',
day: 'numeric',
})
);
if (disabledDates?.length === 1) {
return `${disabledDates} is a disabled date`;
}
if (disabledDates?.length > 1) {
return `${disabledDates.join(', ')} are disabled dates`;
}
return '';
};
const notifyDisableDate = () => {
notify('Cannot create or move an appointment/event to disabled time/date regions.', 'warning', 1000);
};
const onContentReady = (e: SchedulerTypes.ContentReadyEvent) => {
const element = e.component?.element();
element && setComponentAria(element);
};
const applyDisableDatesToDateEditors = (form: ReturnType<FormRef['instance']>) => {
const startDateEditor = form.getEditor('startDate');
startDateEditor?.option('disabledDates', holidays);
const endDateEditor = form.getEditor('endDate');
endDateEditor?.option('disabledDates', holidays);
};
const onAppointmentFormOpening = (e: SchedulerTypes.AppointmentFormOpeningEvent) => {
if (e.appointmentData?.startDate) {
const startDate = new Date(e.appointmentData.startDate);
if (!Utils.isValidAppointmentDate(startDate)) {
e.cancel = true;
notifyDisableDate();
}
applyDisableDatesToDateEditors(e.form);
}
};
const onAppointmentAdding = (e: SchedulerTypes.AppointmentAddingEvent) => {
const isValidAppointment = Utils.isValidAppointment(e.component, e.appointmentData);
if (!isValidAppointment) {
e.cancel = true;
notifyDisableDate();
}
};
const onAppointmentUpdating = (e: SchedulerTypes.AppointmentUpdatingEvent) => {
const isValidAppointment = Utils.isValidAppointment(e.component, e.newData);
if (!isValidAppointment) {
e.cancel = true;
notifyDisableDate();
}
};
const setComponentAria = (element: HTMLElement) => {
const prevAria = element.getAttribute('aria-label') || '';
const description = ariaDescription();
const nextAria = `${prevAria}${description ? ` ${description}` : ''}`;
element.setAttribute('aria-label', nextAria);
};
const App = () => {
const [currentView, setCurrentView] = useState<SchedulerTypes.ViewType>(views[0]);
const DataCellComponent = useMemo(() => (
currentView === 'month' ? DataCellMonth : DataCell
), [currentView]);
const onCurrentViewChange = useCallback((value) => setCurrentView(value), [setCurrentView]);
const renderDateCell = useCallback((itemData) => (
<DateCell itemData={itemData} currentView={currentView} />
), [currentView]);
return (
<Scheduler
dataSource={data}
views={views}
defaultCurrentDate={currentDate}
currentView={currentView}
onCurrentViewChange={onCurrentViewChange}
height={730}
showAllDayPanel={false}
firstDayOfWeek={0}
startDayHour={9}
endDayHour={19}
dataCellComponent={DataCellComponent}
dateCellRender={renderDateCell}
timeCellComponent={TimeCell}
onContentReady={onContentReady}
onAppointmentFormOpening={onAppointmentFormOpening}
onAppointmentAdding={onAppointmentAdding}
onAppointmentUpdating={onAppointmentUpdating}
/>
);
};
export default App;
import React, { useCallback, useMemo, useState } from 'react';
import Scheduler from 'devextreme-react/scheduler';
import notify from 'devextreme/ui/notify';
import { data, holidays } from './data.js';
import Utils from './utils.js';
import DataCell from './DataCell.js';
import DataCellMonth from './DataCellMonth.js';
import DateCell from './DateCell.js';
import TimeCell from './TimeCell.js';
const currentDate = new Date(2021, 3, 27);
const views = ['workWeek', 'month'];
const ariaDescription = () => {
const disabledDates = holidays
.filter((date) => !Utils.isWeekend(date))
.map((date) =>
new Date(date).toLocaleDateString('en-US', {
weekday: 'long',
year: 'numeric',
month: 'long',
day: 'numeric',
}),
);
if (disabledDates?.length === 1) {
return `${disabledDates} is a disabled date`;
}
if (disabledDates?.length > 1) {
return `${disabledDates.join(', ')} are disabled dates`;
}
return '';
};
const notifyDisableDate = () => {
notify(
'Cannot create or move an appointment/event to disabled time/date regions.',
'warning',
1000,
);
};
const onContentReady = (e) => {
const element = e.component?.element();
element && setComponentAria(element);
};
const applyDisableDatesToDateEditors = (form) => {
const startDateEditor = form.getEditor('startDate');
startDateEditor?.option('disabledDates', holidays);
const endDateEditor = form.getEditor('endDate');
endDateEditor?.option('disabledDates', holidays);
};
const onAppointmentFormOpening = (e) => {
if (e.appointmentData?.startDate) {
const startDate = new Date(e.appointmentData.startDate);
if (!Utils.isValidAppointmentDate(startDate)) {
e.cancel = true;
notifyDisableDate();
}
applyDisableDatesToDateEditors(e.form);
}
};
const onAppointmentAdding = (e) => {
const isValidAppointment = Utils.isValidAppointment(e.component, e.appointmentData);
if (!isValidAppointment) {
e.cancel = true;
notifyDisableDate();
}
};
const onAppointmentUpdating = (e) => {
const isValidAppointment = Utils.isValidAppointment(e.component, e.newData);
if (!isValidAppointment) {
e.cancel = true;
notifyDisableDate();
}
};
const setComponentAria = (element) => {
const prevAria = element.getAttribute('aria-label') || '';
const description = ariaDescription();
const nextAria = `${prevAria}${description ? ` ${description}` : ''}`;
element.setAttribute('aria-label', nextAria);
};
const App = () => {
const [currentView, setCurrentView] = useState(views[0]);
const DataCellComponent = useMemo(
() => (currentView === 'month' ? DataCellMonth : DataCell),
[currentView],
);
const onCurrentViewChange = useCallback((value) => setCurrentView(value), [setCurrentView]);
const renderDateCell = useCallback(
(itemData) => (
<DateCell
itemData={itemData}
currentView={currentView}
/>
),
[currentView],
);
return (
<Scheduler
dataSource={data}
views={views}
defaultCurrentDate={currentDate}
currentView={currentView}
onCurrentViewChange={onCurrentViewChange}
height={730}
showAllDayPanel={false}
firstDayOfWeek={0}
startDayHour={9}
endDayHour={19}
dataCellComponent={DataCellComponent}
dateCellRender={renderDateCell}
timeCellComponent={TimeCell}
onContentReady={onContentReady}
onAppointmentFormOpening={onAppointmentFormOpening}
onAppointmentAdding={onAppointmentAdding}
onAppointmentUpdating={onAppointmentUpdating}
/>
);
};
export default App;
import React from 'react';
import Utils from './utils.ts';
type DataCellProps = {
className: string
data: {
startDate: Date;
}
};
const DataCell = (props: React.PropsWithChildren<DataCellProps>) => {
const { startDate } = props.data;
const isDinner = Utils.isDinner(startDate);
let cssClasses = props.className || '';
if (Utils.isDisableDate(startDate)) {
cssClasses += ' disable-date';
} else if (isDinner) {
cssClasses += ' dinner';
}
return (
<div className={cssClasses}>
{props.children}
</div>
);
};
export default DataCell;
import React from 'react';
import DataCell from './DataCell.tsx';
type DataCellMonthProps = {
data: { startDate: Date; };
};
const DataCellMonth = (props: DataCellMonthProps) => {
const { startDate } = props.data;
return (
<DataCell data={props.data} className='dx-scheduler-date-table-cell-text'>
{startDate.getDate()}
</DataCell>
);
};
export default DataCellMonth;
import React from 'react';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import Utils from './utils.ts';
interface DateCellProps {
itemData: any;
currentView: SchedulerTypes.ViewType;
}
const DateCell = (props: DateCellProps) => {
const { currentView, date, text } = props.itemData;
const isDisabled = currentView === 'month'
? Utils.isWeekend(date)
: Utils.isDisableDate(date);
return (
<div className={isDisabled ? 'disable-date' : undefined}>
<div>{text}</div>
</div>
);
};
export default DateCell;
import React from 'react';
import Utils from './utils.ts';
type TimeCellProps = {
data: { date: Date; text: string; };
};
const TimeCell = (props: TimeCellProps) => {
const { date, text } = props.data;
const isDinner = Utils.isDinner(date);
const hasCoffeeCupIcon = Utils.hasCoffeeCupIcon(date);
return (
<div className={isDinner ? 'dinner' : undefined}>
{text}
{hasCoffeeCupIcon && <div className='cafe' />}
</div>
);
};
export default TimeCell;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
export const dinnerTime = { from: 12, to: 13 };
export const holidays = [
new Date(2021, 3, 29),
new Date(2021, 5, 6),
];
export const data: SchedulerTypes.Appointment[] = [
{
text: 'Website Re-Design Plan',
startDate: new Date(2021, 3, 26, 9, 30),
endDate: new Date(2021, 3, 26, 11, 30),
},
{
text: 'Install New Router in Dev Room',
startDate: new Date(2021, 3, 26, 13),
endDate: new Date(2021, 3, 26, 14),
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2021, 3, 27, 10),
endDate: new Date(2021, 3, 27, 11),
},
{
text: 'Final Budget Review',
startDate: new Date(2021, 3, 27, 13, 30),
endDate: new Date(2021, 3, 27, 15),
},
{
text: 'New Brochures',
startDate: new Date(2021, 3, 26, 15),
endDate: new Date(2021, 3, 26, 16, 15),
},
{
text: 'Install New Database',
startDate: new Date(2021, 3, 28, 9, 45),
endDate: new Date(2021, 3, 28, 12),
},
{
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2021, 3, 28, 14, 30),
endDate: new Date(2021, 3, 28, 16, 30),
},
{
text: 'Upgrade Personal Computers',
startDate: new Date(2021, 3, 27, 15, 30),
endDate: new Date(2021, 3, 27, 16, 45),
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2021, 4, 3, 13),
endDate: new Date(2021, 4, 3, 15),
},
{
text: 'Brochure Design Review',
startDate: new Date(2021, 4, 4, 15, 30),
endDate: new Date(2021, 4, 5),
},
{
text: 'Create Icons for Website',
startDate: new Date(2021, 3, 30, 10),
endDate: new Date(2021, 3, 30, 12),
},
{
text: 'Upgrade Server Hardware',
startDate: new Date(2021, 3, 30, 16, 30),
endDate: new Date(2021, 3, 30, 18),
},
{
text: 'Submit New Website Design',
startDate: new Date(2021, 4, 5, 10),
endDate: new Date(2021, 4, 5, 11, 30),
},
{
text: 'Launch New Website',
startDate: new Date(2021, 3, 30, 14, 30),
endDate: new Date(2021, 3, 30, 16, 10),
},
];
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import { dinnerTime, holidays } from './data.ts';
export default class Utils {
static isHoliday(date: Date) {
const localeDate = date.toLocaleDateString();
return holidays.filter((holiday) => holiday.toLocaleDateString() === localeDate).length > 0;
}
static isWeekend(date: Date) {
const day = date.getDay();
return day === 0 || day === 6;
}
static isDisableDate(date: Date) {
return Utils.isHoliday(date) || Utils.isWeekend(date);
}
static isDinner(date: Date) {
const hours = date.getHours();
return hours >= dinnerTime.from && hours < dinnerTime.to;
}
static hasCoffeeCupIcon(date: Date) {
const hours = date.getHours();
const minutes = date.getMinutes();
return hours === dinnerTime.from && minutes === 0;
}
static isValidAppointment(component: SchedulerTypes.AppointmentAddingEvent['component'], appointmentData: SchedulerTypes.AppointmentAddingEvent['appointmentData']) {
const startDate = appointmentData.startDate ? new Date(appointmentData.startDate) : new Date();
const endDate = appointmentData.endDate ? new Date(appointmentData.endDate) : new Date();
const cellDuration = Number(component.option('cellDuration'));
return Utils.isValidAppointmentInterval(startDate, endDate, cellDuration);
}
static isValidAppointmentInterval(startDate: Date, endDate: Date, cellDuration: number) {
const edgeEndDate = new Date(endDate.getTime() - 1);
if (!Utils.isValidAppointmentDate(edgeEndDate)) {
return false;
}
const durationInMs = cellDuration * 60 * 1000;
const date = startDate;
while (date <= endDate) {
if (!Utils.isValidAppointmentDate(date)) {
return false;
}
const newDateTime = date.getTime() + durationInMs - 1;
date.setTime(newDateTime);
}
return true;
}
static isValidAppointmentDate(date: Date) {
return !Utils.isHoliday(date) && !Utils.isDinner(date) && !Utils.isWeekend(date);
}
}
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import Utils from './utils.js';
const DataCell = (props) => {
const { startDate } = props.data;
const isDinner = Utils.isDinner(startDate);
let cssClasses = props.className || '';
if (Utils.isDisableDate(startDate)) {
cssClasses += ' disable-date';
} else if (isDinner) {
cssClasses += ' dinner';
}
return <div className={cssClasses}>{props.children}</div>;
};
export default DataCell;
import React from 'react';
import DataCell from './DataCell.js';
const DataCellMonth = (props) => {
const { startDate } = props.data;
return (
<DataCell
data={props.data}
className="dx-scheduler-date-table-cell-text"
>
{startDate.getDate()}
</DataCell>
);
};
export default DataCellMonth;
import React from 'react';
import Utils from './utils.js';
const DateCell = (props) => {
const { currentView, date, text } = props.itemData;
const isDisabled = currentView === 'month' ? Utils.isWeekend(date) : Utils.isDisableDate(date);
return (
<div className={isDisabled ? 'disable-date' : undefined}>
<div>{text}</div>
</div>
);
};
export default DateCell;
import React from 'react';
import Utils from './utils.js';
const TimeCell = (props) => {
const { date, text } = props.data;
const isDinner = Utils.isDinner(date);
const hasCoffeeCupIcon = Utils.hasCoffeeCupIcon(date);
return (
<div className={isDinner ? 'dinner' : undefined}>
{text}
{hasCoffeeCupIcon && <div className="cafe" />}
</div>
);
};
export default TimeCell;
import { dinnerTime, holidays } from './data.js';
export default class Utils {
static isHoliday(date) {
const localeDate = date.toLocaleDateString();
return holidays.filter((holiday) => holiday.toLocaleDateString() === localeDate).length > 0;
}
static isWeekend(date) {
const day = date.getDay();
return day === 0 || day === 6;
}
static isDisableDate(date) {
return Utils.isHoliday(date) || Utils.isWeekend(date);
}
static isDinner(date) {
const hours = date.getHours();
return hours >= dinnerTime.from && hours < dinnerTime.to;
}
static hasCoffeeCupIcon(date) {
const hours = date.getHours();
const minutes = date.getMinutes();
return hours === dinnerTime.from && minutes === 0;
}
static isValidAppointment(component, appointmentData) {
const startDate = appointmentData.startDate ? new Date(appointmentData.startDate) : new Date();
const endDate = appointmentData.endDate ? new Date(appointmentData.endDate) : new Date();
const cellDuration = Number(component.option('cellDuration'));
return Utils.isValidAppointmentInterval(startDate, endDate, cellDuration);
}
static isValidAppointmentInterval(startDate, endDate, cellDuration) {
const edgeEndDate = new Date(endDate.getTime() - 1);
if (!Utils.isValidAppointmentDate(edgeEndDate)) {
return false;
}
const durationInMs = cellDuration * 60 * 1000;
const date = startDate;
while (date <= endDate) {
if (!Utils.isValidAppointmentDate(date)) {
return false;
}
const newDateTime = date.getTime() + durationInMs - 1;
date.setTime(newDateTime);
}
return true;
}
static isValidAppointmentDate(date) {
return !Utils.isHoliday(date) && !Utils.isDinner(date) && !Utils.isWeekend(date);
}
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const dinnerTime = { from: 12, to: 13 };
export const holidays = [new Date(2021, 3, 29), new Date(2021, 5, 6)];
export const data = [
{
text: 'Website Re-Design Plan',
startDate: new Date(2021, 3, 26, 9, 30),
endDate: new Date(2021, 3, 26, 11, 30),
},
{
text: 'Install New Router in Dev Room',
startDate: new Date(2021, 3, 26, 13),
endDate: new Date(2021, 3, 26, 14),
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2021, 3, 27, 10),
endDate: new Date(2021, 3, 27, 11),
},
{
text: 'Final Budget Review',
startDate: new Date(2021, 3, 27, 13, 30),
endDate: new Date(2021, 3, 27, 15),
},
{
text: 'New Brochures',
startDate: new Date(2021, 3, 26, 15),
endDate: new Date(2021, 3, 26, 16, 15),
},
{
text: 'Install New Database',
startDate: new Date(2021, 3, 28, 9, 45),
endDate: new Date(2021, 3, 28, 12),
},
{
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2021, 3, 28, 14, 30),
endDate: new Date(2021, 3, 28, 16, 30),
},
{
text: 'Upgrade Personal Computers',
startDate: new Date(2021, 3, 27, 15, 30),
endDate: new Date(2021, 3, 27, 16, 45),
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2021, 4, 3, 13),
endDate: new Date(2021, 4, 3, 15),
},
{
text: 'Brochure Design Review',
startDate: new Date(2021, 4, 4, 15, 30),
endDate: new Date(2021, 4, 5),
},
{
text: 'Create Icons for Website',
startDate: new Date(2021, 3, 30, 10),
endDate: new Date(2021, 3, 30, 12),
},
{
text: 'Upgrade Server Hardware',
startDate: new Date(2021, 3, 30, 16, 30),
endDate: new Date(2021, 3, 30, 18),
},
{
text: 'Submit New Website Design',
startDate: new Date(2021, 4, 5, 10),
endDate: new Date(2021, 4, 5, 11, 30),
},
{
text: 'Launch New Website',
startDate: new Date(2021, 3, 30, 14, 30),
endDate: new Date(2021, 3, 30, 16, 10),
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
/* stylelint-disable-next-line at-rule-no-vendor-prefix, at-rule-prelude-no-invalid */
@-moz-document url-prefix() {
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell {
position: relative;
}
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell .disable-date {
position: absolute;
width: 100%;
height: 100%;
}
}
.disable-date,
.dinner {
height: 100%;
width: 100%;
}
.disable-date {
background-image:
repeating-linear-gradient(
135deg,
var(--dx-datagrid-row-alternation-bg),
var(--dx-datagrid-row-alternation-bg) 2px,
transparent 2px,
transparent 6px
);
color: var(--dx-color-success);
}
.dx-scheduler-header-panel-cell .disable-date {
display: flex;
flex-direction: column;
justify-content: center;
}
.dx-theme-fluent .dx-scheduler-header-panel-cell .disable-date,
.dx-theme-material .dx-scheduler-header-panel-cell .disable-date {
flex-direction: row;
align-items: flex-end;
justify-content: initial;
}
.dinner {
background: var(--dx-datagrid-row-alternation-bg);
}
.dx-scheduler-time-panel-cell .dinner {
color: var(--dx-color-success);
font-weight: 400;
background: transparent;
}
.dx-draggable {
cursor: auto;
}
td.dx-scheduler-time-panel-cell .dinner .cafe {
height: 200%;
width: 100%;
left: 50%;
mask: url('data:image/svg+xml;utf8,<svg xmlns="http://www.w3.org/2000/svg" height="24" viewBox="0 0 24 24" width="24"><path d="M0 0h24v24H0V0z" fill="none"/><path d="M20 3H4v10c0 2.21 1.79 4 4 4h6c2.21 0 4-1.79 4-4v-3h2c1.11 0 2-.9 2-2V5c0-1.11-.89-2-2-2zm0 5h-2V5h2v3zM4 19h16v2H4z"/></svg>');
mask-repeat: no-repeat;
-webkit-mask-position-y: 50%;
-webkit-mask-position-x: 100%;
margin-top: -4px;
background-color: var(--dx-color-success);
}
.dx-scheduler-date-table-cell {
padding: 0;
opacity: 1;
}
@media all and (-ms-high-contrast: none) {
td.dx-scheduler-time-panel-cell .dinner .cafe {
background-color: transparent;
}
}